%define base_name	jmeter
%define ajm		ApacheJMeter
%define name		jakarta-%{base_name}
%define version		2.0.2
%define release		2jpp
%define	section		free


Name:		%{name}
Summary:	Apache JMeter
Url:		http://jakarta.apache.org/jmeter
Version:	%{version}
Release:	%{release}
Epoch:		0
License:	Apache License 2.0
Group:		Development/Testing
Vendor:		JPackage Project
Distribution:	JPackage
BuildArch:	noarch
Source0:	jakarta-jmeter-2.0.2_src.tgz
Source1:	jmeter.script
Patch0:		jakarta-jmeter-2.0.2-build_xml.patch
Patch1:		jakarta-jmeter-2.0.2-LoggingManager.patch

BuildRequires:  jpackage-utils >= 0:1.5
BuildRequires:  ant >= 0:1.6
BuildRequires:  junit
#
BuildRequires:  avalon-excalibur
BuildRequires:  avalon-framework
BuildRequires:  avalon-logkit
BuildRequires:  jakarta-commons-collections
BuildRequires:  jakarta-commons-httpclient
BuildRequires:  jakarta-commons-logging
BuildRequires:  oro
BuildRequires:  rhino
BuildRequires:  jtidy
BuildRequires:  soap
BuildRequires:  jdom
BuildRequires:  xalan-j2
BuildRequires:  xerces-j2
BuildRequires:  xml-commons-apis
BuildRequires:  bsf
BuildRequires:  bsh2


BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot

%description
Apache JMeter is a 100% pure Java desktop application 
designed to load test functional behavior and measure 
performance. It was originally designed for testing 
Web Applications but has since expanded to other test 
functions.

%package javadoc
Summary:	Javadoc for %{name}
Group:		Development/Documentation

%description javadoc
Javadoc for %{name}.

%package manual
Summary:	Documents for %{name}
Group:		Development/Documentation

%description manual
Documents for %{name}.

%prep
%setup -q -n %{name}-%{version}
chmod -R go=u-w *
find . -name "*.jar" -exec rm -f {} \;
mkdir -p lib
pushd lib
ln -sf $(build-classpath avalon-excalibur) .
ln -sf $(build-classpath avalon-logkit) .
ln -sf $(build-classpath avalon-framework) .
ln -sf $(build-classpath commons-collections) .
ln -sf $(build-classpath commons-httpclient) .
ln -sf $(build-classpath commons-logging) .
ln -sf $(build-classpath oro) .
ln -sf $(build-classpath js) .
ln -sf $(build-classpath junit) .
ln -sf $(build-classpath jtidy) .
ln -sf $(build-classpath soap) .
ln -sf $(build-classpath jdom) .
ln -sf $(build-classpath xalan-j2) .
ln -sf $(build-classpath xerces-j2) .
ln -sf $(build-classpath xml-commons-apis) .
mkdir opt
pushd opt
ln -sf $(build-classpath bsf) .
ln -sf $(build-classpath bsh2/bsh-core) .
build-classpath jaf && ln -sf $(build-classpath jaf) .
build-classpath javamail/mailapi && ln -sf $(build-classpath javamail/mailapi) .
popd
popd

%patch0 -b .sav
%patch1 -b .sav

%build
export CLASSPATH=$(build-classpath velocity jdom commons-collections)
ant all docs-all

%install
rm -rf $RPM_BUILD_ROOT
# script
install -d -m 755 $RPM_BUILD_ROOT%{_bindir}
install -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{_bindir}/jmeter
# home
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{base_name}
# bin
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{base_name}/bin
install -m 644 bin/%{ajm}.jar $RPM_BUILD_ROOT%{_datadir}/%{base_name}/bin
install -m 755 bin/jmeter $RPM_BUILD_ROOT%{_datadir}/%{base_name}/bin
install -m 755 bin/jmeter-server $RPM_BUILD_ROOT%{_datadir}/%{base_name}/bin
install -m 644 bin/jmeter.properties $RPM_BUILD_ROOT%{_datadir}/%{base_name}/bin
install -m 644 bin/jmetertest.properties $RPM_BUILD_ROOT%{_datadir}/%{base_name}/bin
install -m 644 bin/log4j.conf $RPM_BUILD_ROOT%{_datadir}/%{base_name}/bin
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{base_name}/bin/testfiles
cp -pr bin/testfiles/* $RPM_BUILD_ROOT%{_datadir}/%{base_name}/bin/testfiles

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{base_name}
install -m 644 lib/ext/%{ajm}_components.jar $RPM_BUILD_ROOT%{_javadir}/%{base_name}/components-%{version}.jar
install -m 644 lib/ext/%{ajm}_core.jar $RPM_BUILD_ROOT%{_javadir}/%{base_name}/core-%{version}.jar
install -m 644 lib/ext/%{ajm}_ldap.jar $RPM_BUILD_ROOT%{_javadir}/%{base_name}/ldap-%{version}.jar
install -m 644 lib/ext/%{ajm}_functions.jar $RPM_BUILD_ROOT%{_javadir}/%{base_name}/functions-%{version}.jar
install -m 644 lib/ext/%{ajm}_monitors.jar $RPM_BUILD_ROOT%{_javadir}/%{base_name}/monitors-%{version}.jar
install -m 644 lib/ext/%{ajm}_tcp.jar $RPM_BUILD_ROOT%{_javadir}/%{base_name}/tcp-%{version}.jar
install -m 644 lib/ext/%{ajm}_http.jar $RPM_BUILD_ROOT%{_javadir}/%{base_name}/http-%{version}.jar
install -m 644 lib/ext/%{ajm}_jdbc.jar $RPM_BUILD_ROOT%{_javadir}/%{base_name}/jdbc-%{version}.jar
install -m 644 lib/ext/%{ajm}_java.jar $RPM_BUILD_ROOT%{_javadir}/%{base_name}/java-%{version}.jar
install -m 644 lib/ext/%{ajm}_ftp.jar $RPM_BUILD_ROOT%{_javadir}/%{base_name}/ftp-%{version}.jar
install -m 644 lib/htmlparser.jar $RPM_BUILD_ROOT%{_javadir}/%{base_name}/htmlparser-%{version}.jar
install -m 644 lib/jorphan.jar $RPM_BUILD_ROOT%{_javadir}/%{base_name}/jorphan-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir}/%{base_name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# lib
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{base_name}/lib
ln -s %{_javadir}/avalon-excalibur.jar $RPM_BUILD_ROOT%{_datadir}/%{base_name}/lib/avalon-excalibur.jar # ghost symlink
ln -s %{_javadir}/avalon-framework.jar $RPM_BUILD_ROOT%{_datadir}/%{base_name}/lib/avalon-framework.jar # ghost symlink
ln -s %{_javadir}/avalon-logkit.jar $RPM_BUILD_ROOT%{_datadir}/%{base_name}/lib/avalon-logkit.jar # ghost symlink
ln -s %{_javadir}/commons-collections.jar $RPM_BUILD_ROOT%{_datadir}/%{base_name}/lib/commons-collections.jar # ghost symlink
ln -s %{_javadir}/commons-httpclient.jar $RPM_BUILD_ROOT%{_datadir}/%{base_name}/lib/commons-httpclient.jar # ghost symlink
ln -s %{_javadir}/commons-logging.jar $RPM_BUILD_ROOT%{_datadir}/%{base_name}/lib/commons-logging.jar # ghost symlink
ln -s %{_javadir}/%{base_name}/htmlparser.jar $RPM_BUILD_ROOT%{_datadir}/%{base_name}/lib/htmlparser.jar # ghost symlink
ln -s %{_javadir}/jdom.jar $RPM_BUILD_ROOT%{_datadir}/%{base_name}/lib/jdom.jar # ghost symlink
ln -s %{_javadir}/%{base_name}/jorphan.jar $RPM_BUILD_ROOT%{_datadir}/%{base_name}/lib/jorphan.jar # ghost symlink
ln -s %{_javadir}/js.jar $RPM_BUILD_ROOT%{_datadir}/%{base_name}/lib/js.jar # ghost symlink
ln -s %{_javadir}/jtidy.jar $RPM_BUILD_ROOT%{_datadir}/%{base_name}/lib/jtidy.jar # ghost symlink
ln -s %{_javadir}/junit.jar $RPM_BUILD_ROOT%{_datadir}/%{base_name}/lib/junit.jar # ghost symlink
ln -s %{_javadir}/oro.jar $RPM_BUILD_ROOT%{_datadir}/%{base_name}/lib/oro.jar # ghost symlink
ln -s %{_javadir}/soap.jar $RPM_BUILD_ROOT%{_datadir}/%{base_name}/lib/soap.jar # ghost symlink
ln -s %{_javadir}/xalan-j2.jar $RPM_BUILD_ROOT%{_datadir}/%{base_name}/lib/xalan-j2.jar # ghost symlink
ln -s %{_javadir}/xerces-j2.jar $RPM_BUILD_ROOT%{_datadir}/%{base_name}/lib/xerces-j2.jar # ghost symlink
ln -s %{_javadir}/xml-commons-apis.jar $RPM_BUILD_ROOT%{_datadir}/%{base_name}/lib/xml-commons-apis.jar # ghost symlink
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{base_name}/lib/ext
ln -s %{_javadir}/%{base_name}/components.jar $RPM_BUILD_ROOT%{_datadir}/%{base_name}/lib/ext/ApacheJMeter_components.jar # ghost symlink
ln -s %{_javadir}/%{base_name}/core.jar $RPM_BUILD_ROOT%{_datadir}/%{base_name}/lib/ext/ApacheJMeter_core.jar # ghost symlink
ln -s %{_javadir}/%{base_name}/ftp.jar $RPM_BUILD_ROOT%{_datadir}/%{base_name}/lib/ext/ApacheJMeter_ftp.jar # ghost symlink
ln -s %{_javadir}/%{base_name}/functions.jar $RPM_BUILD_ROOT%{_datadir}/%{base_name}/lib/ext/ApacheJMeter_functions.jar # ghost symlink
ln -s %{_javadir}/%{base_name}/http.jar $RPM_BUILD_ROOT%{_datadir}/%{base_name}/lib/ext/ApacheJMeter_http.jar # ghost symlink
ln -s %{_javadir}/%{base_name}/java.jar $RPM_BUILD_ROOT%{_datadir}/%{base_name}/lib/ext/ApacheJMeter_java.jar # ghost symlink
ln -s %{_javadir}/%{base_name}/jdbc.jar $RPM_BUILD_ROOT%{_datadir}/%{base_name}/lib/ext/ApacheJMeter_jdbc.jar # ghost symlink
ln -s %{_javadir}/%{base_name}/ldap.jar $RPM_BUILD_ROOT%{_datadir}/%{base_name}/lib/ext/ApacheJMeter_ldap.jar # ghost symlink
ln -s %{_javadir}/%{base_name}/monitors.jar $RPM_BUILD_ROOT%{_datadir}/%{base_name}/lib/ext/ApacheJMeter_monitors.jar # ghost symlink
ln -s %{_javadir}/%{base_name}/tcp.jar $RPM_BUILD_ROOT%{_datadir}/%{base_name}/lib/ext/ApacheJMeter_tcp.jar # ghost symlink
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{base_name}/lib/opt
ln -s %{_javadir}/bsf.jar $RPM_BUILD_ROOT%{_datadir}/%{base_name}/lib/opt/bsf.jar # ghost symlink
ln -s %{_javadir}/bsh2/bsh-bsf.jar $RPM_BUILD_ROOT%{_datadir}/%{base_name}/lib/opt/bsh-bsf.jar # ghost symlink
ln -s %{_javadir}/bsh2/bsh-classgen.jar $RPM_BUILD_ROOT%{_datadir}/%{base_name}/lib/opt/bsh-classgen.jar # ghost symlink
ln -s %{_javadir}/bsh2/bsh-classpath.jar $RPM_BUILD_ROOT%{_datadir}/%{base_name}/lib/opt/bsh-classpath.jar # ghost symlink
ln -s %{_javadir}/bsh2/bsh-commands.jar $RPM_BUILD_ROOT%{_datadir}/%{base_name}/lib/opt/bsh-commands.jar # ghost symlink
ln -s %{_javadir}/bsh2/bsh-core.jar $RPM_BUILD_ROOT%{_datadir}/%{base_name}/lib/opt/bsh-core.jar # ghost symlink
ln -s %{_javadir}/bsh2/bsh-reflect.jar $RPM_BUILD_ROOT%{_datadir}/%{base_name}/lib/opt/bsh-reflect.jar # ghost symlink
ln -s %{_javadir}/bsh2/bsh-util.jar $RPM_BUILD_ROOT%{_datadir}/%{base_name}/lib/opt/bsh-util.jar # ghost symlink


# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{base_name}-%{version}
cp -pr docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{base_name}-%{version}
ln -s %{base_name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{base_name} # ghost symlink
rm -rf docs/api

# docs
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{base_name}
cp -pr docs/* $RPM_BUILD_ROOT%{_docdir}/%{base_name}
install -m 644 LICENSE $RPM_BUILD_ROOT%{_docdir}/%{base_name}
install -m 644 NOTICE $RPM_BUILD_ROOT%{_docdir}/%{base_name}
install -m 644 README $RPM_BUILD_ROOT%{_docdir}/%{base_name}
ln -sf %{_javadocdir}/%{base_name} $RPM_BUILD_ROOT%{_docdir}/%{base_name}/api # ghost symlink
ln -sf %{_docdir}/%{base_name} $RPM_BUILD_ROOT%{_datadir}/%{base_name}/docs # ghost symlink
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{base_name}/printable_docs
cp -pr printable_docs/* $RPM_BUILD_ROOT%{_datadir}/%{base_name}/printable_docs

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{base_name}
ln -s %{base_name}-%{version} %{_javadocdir}/%{base_name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{base_name}
fi

%files
%defattr(-,root,root)
%dir %{_docdir}/%{base_name}
%{_docdir}/%{base_name}/LICENSE
%{_docdir}/%{base_name}/NOTICE
%{_docdir}/%{base_name}/README
%{_docdir}/%{base_name}/usermanual
%attr(755, root, root) %{_bindir}/*
%{_javadir}/%{base_name}
%{_datadir}/%{base_name}

%files javadoc
%defattr(-,root,root)
%{_docdir}/%{base_name}/api
%{_javadocdir}/%{base_name}-%{version}
%ghost %doc %{_javadocdir}/%{base_name}

%files manual
%defattr(-,root,root)
%{_docdir}/%{base_name}/*.html
%{_docdir}/%{base_name}/demos
%{_docdir}/%{base_name}/extending
%{_docdir}/%{base_name}/images
%{_docdir}/%{base_name}/localising


%changelog
* Wed Jun 15 2005 Ralph Apel <r.apel at r-apel.de> 0:2.0.2-2jpp
- Include htmlparser.jar and jorphan.jar in /usr/share/java/jmeter
- Fix misnamed /usr/bin/jmeter.script to /usr/bin/jmeter

* Wed Feb 09 2005 Ralph Apel <r.apel at r-apel.de> 0:2.0.2-1jpp
- First release

